import matplotlib.pyplot as plt
from matplotlib.ticker import FuncFormatter
import numpy as np
from brokenaxes import brokenaxes
import os
import sys

plt.rcParams.update({'font.size': 22})

def draw_bar(item:str, datas:dict, attrs:list, x_bars:list, label:bool, alias={}):
    width = 0.15
    total_width = width * len(attrs) + 0.15
    x = [0 for _ in range(len(x_bars))]
    for i in range(len(x_bars)):
        x[i] = total_width * i
    x = np.array(x)
    x_length = total_width * len(x_bars)

    # patterns=('//','xx','--','\\\\','oo','oo')
    rects=[]
    fig,ax=plt.subplots()
    for i in range(len(attrs)):
        attr = attrs[i]
        # rects.append(ax.bar(x+width*i, datas[attr],width, label=attr if attr not in alias else alias[attr],hatch=patterns[i],color='w',edgecolor='k'))
        rects.append(ax.bar(x+width*i, datas[attr],width, label=attr if attr not in alias else alias[attr],edgecolor='k'))

    # ax.set_yscale('symlog')
    ax.set_xticks(x+width*((len(attrs)-1)/2))
    # ax.set_yticks(np.arange(0.0, 0.3, 0.1))
    ax.set_xticklabels(x_bars)
    # ax.set_xlabel('Models')
    if label:
        ax.set_ylabel('10K samples/sec')
    ax.legend(prop={'size': 22})
    # fig.set_figheight(1.8 * x_length)

    fig.tight_layout()
    fig.set_figwidth(7)
    # fig.text(0.2, 0.95, '1e4')
    cmd = 'mkdir Hotstorage'
    os.system(cmd)
    plt.show()
    path = "./Hotstorage/%s.pdf"%(item)
    fig.savefig(path,dpi=1024,format='pdf')

if __name__ == '__main__':
        # draw_line(item,datas,attrs,x_bars)
    #filename = 'training_performance.csv'
    #split_symbol = ','
    #datas = dict()
    #with open(filename, 'r') as f:
    #    line = f.readline().strip().split(split_symbol)
    #    size = line[1:]
    #    for line in f.readlines():
    #        line = line.strip().split(split_symbol)
    #        key = line[0]
    #        value = line[1:]
    #        value = [float(v)/10000 for v in value]
    #        datas[key] = value
    #for key in datas:
    #    print(key,end=' ')
    #    
    datas = {}
    size = ['resnet18', 'alexnet']
    datas["ebs"] = [1.4328, 1.4420, ]
    datas["nvme"] = [1.4301, 1.43337, ]
    datas['mem'] = [1.5584, 2.6622]

   
    draw_bar("image-performance-IO",datas,['ebs', 'nvme', 'mem'],size, True,
        {
            'ebs': 'ebs',
            'nvme': 'nvme',
            'mem': 'mem'
        })
